% ..  .
%   MATLAB. 2023
%Script 1.7
%    ,
%     
clc; clear all; close all
%  
% 
U0=[1 .5];
% 
t0=[0 .5];
%     
tmin=-1.5;
tmax=1;
% 
dt=.001;
%  
t=tmin:dt:tmax;
%  
delta_fun=@(t) 1*(t==0);
step_fun=@(t) 1*(t>0)+.5*(t==0);
%  
nU0=length(U0);
nt=length(t);
u1=zeros(nU0,nt);
u2=zeros(nU0,nt);
u3=zeros(nU0,nt);
str_leg=cell(nU0,1);
% 
for k=1:nU0;
str_leg{k}=['U_0 = ',num2str(U0(k)),' , t_0 = ',num2str(t0(k)),' '];
u1(k,:)=U0(k)*delta_fun(t-t0(k));
u2(k,:)=U0(k)*step_fun(t-t0(k));
u3(k,:)=U0(k)*sign(t-t0(k));
end
%  
du=.1;
subplot(3,1,1)
plot(t,u1)
xlim([tmin tmax])
umin=-du;
umax=max(U0)+du;
ylim([umin umax])
grid
legend(str_leg,'Location','NorthWest')
text(t0,.93*U0,'\uparrow','HorizontalAlignment','Center')
title('  ')
subplot(3,1,2)
plot(t,u2)
xlim([tmin tmax])
umin=-du;
umax=max(U0)+du;
ylim([umin umax])
grid
legend(str_leg,'Location','NorthWest')
title('  ')
subplot(3,1,3)
plot(t,u3)
xlim([tmin tmax])
umax=max(U0)+du;
ylim([-umax umax])
grid
legend(str_leg,'Location','NorthWest')
title(' ')