% ..  .
%   MATLAB. 2023
%Script 2.4
%    
%    
clc; clear all; close all
%  
% 
U0=1;
%   
T=1;
%  (   )
q=1.5;
%  ()
NT=1;
% 
dt=.001;
%     (  )
nh=[1 2 4 5];
nh_max=max(nh);
% 
% 
T0=q*T;
%  
w0=2*pi/T0;
%   
tmax=(NT-1)/2*T0+q*T/2;
%  
t=-tmax:dt:tmax;
%  
d=-(NT-1)/2*T0:T0:(NT-1)/2*T0;
%  
u0=U0*pulstran(t,d,'tripuls',T);
%  
h=zeros(nh_max,length(t));
%   
c0=.5*U0/q;
k=1:nh_max; c=.5*U0/q*sinc(.5*k/q).^2;
% 
for k=1:nh_max
h(k,:)=c(k)*cos(k*w0*t);
end
%    
s=c0+2*cumsum(h);
%     
Ps=c0^2+2*cumsum(c.^2);
%     
ymi=-0.5; yma=U0+.5;
n=0;
for k=nh
n=n+1;
subplot(length(nh)/2,2,n)    
plot(t,s(k,:)) 
grid
ylim([ymi yma])
hold on
plot(t,u0,'k')
title(['N = ',num2str(k)])
xlabel('t, ')
ylabel('s_N(t), ')
end
%  
disp(' :')
disp('-----------------------------')
fprintf('-  %f ;\n',U0)
fprintf('-  %f ;\n',T)
fprintf('-  %f;\n',q)
fprintf('-  %f ;\n',c0)
disp('  :')
for k=1:nh_max
fprintf('%u-: %9.6f ;\n',k,c(k))
end
P=U0^2/(3*q);
fprintf('-  %f .\n',P)
disp(' ')
%  
disp('  :')
disp('------------------------------')
for k=nh
fprintf('- N = %u: %9.6f ;\n',k,Ps(k))
end