% ..  .
%   MATLAB. 2023
%Script 7.4
%   , 
%     
%  ,   ,   
%
clear all; close all; clc
%  
% 
U0=1;
% ""
alpha=1;
%1- 
%     
tmin=-12/alpha; tmax=12/alpha;
dt=.01;
t=tmin:dt:tmax;
u=U0./(1+(alpha*t).^2);
ug=u.*(alpha*t);
subplot(2,2,1)
plot(t,u)
grid
xlim([tmin tmax])
xlabel('t, ')
ylabel('u(t), ')
str=[' u(t)  U_0 =',num2str(U0),...
    ' , \alpha = ',num2str(alpha),' ^{-1}'];
title(str)
subplot(2,2,3)
plot(t,ug)
grid
xlim([tmin tmax])
xlabel('t, ')
ylabel('u_g(t), ')
title(' u_g(t)')
%       
fmin=-alpha; fmax=alpha;
df=.001;
f=fmin:df:fmax;
w=2*pi*f;
U=pi*U0/alpha*exp(-abs(w)/alpha);
Ug=U.*sign(f);
subplot(2,2,2)
plot(f,U)
grid
xlim([fmin fmax])
xlabel('f, ')
ylabel('U(f), /')
title('  u(t)')
subplot(2,2,4)
plot(f,Ug)
grid
xlim([fmin fmax])
xlabel('f, ')
ylabel('jU_g(f), /')
title('  u_g(t)')
%2- 
%   
a=U0./sqrt(1+(alpha*t).^2);
figure;
subplot(2,2,1)
plot(t,a,t,u,':')
grid
xlim([tmin tmax])
legend('a(t)','u(t)')
xlabel('t, ')
ylabel('a(t), ')
title('  z(t)')
%    
psi=atan(alpha*t);
subplot(2,2,3)
plot(t,psi)
grid
xlim([tmin tmax])
xlabel('t, ')
ylabel('\psi(t), ')
title('   z(t)')
%   
fmin=-.04*alpha; fmax=.4*alpha;
df=.001;
f=fmin:df:fmax;
w=2*pi*f;
fun=@(w) (2*pi*U0/alpha)^2*exp(-2*w/alpha).*(w>=0);
Rz=fun(w);
subplot(2,2,2)
plot(f,Rz)
hold on
% f0
f0=alpha/(4*pi);
plot(f0,0,'.r')
text(f0,.1*max(Rz),'f_0')
grid
xlim([fmin fmax])
xlabel('f, ')
ylabel('R_z(f), /')
title('  z(t)')
%    
freq=alpha./(1+(alpha*t).^2)/(2*pi);
f0=ones(1,length(t))*alpha/(4*pi);
subplot(2,2,4)
plot(freq,t,f0,t,'--r')
grid
xlim([fmin fmax])
ylim([tmin tmax])
xlabel('f(t), ')
ylabel('t, ')
title('   z(t)')