% ..  .
%   MATLAB. 2023
%Script 3.7
%    
% 
%  erf_series(z)    erf(z)
%  z
clc; clear all; close all
%  
% 
U0=1;
% ""
a=1;
% 
T=1;
%   
tmax=T;
%   
dt=.001;
%  
fmax=3/a;
%   
df=.001;
% 
%  
t=-tmax:dt:tmax;
% 
fun=@(t) exp(-(a*t).^2).*(abs(t)<=T/2);
% 
u=U0*fun(t);
subplot(3,1,1)
plot(t,u)
ylim([-.1 U0+.1])
grid
xlabel('t, ')
ylabel('u(t), ')
str=[' , U_0 = ',num2str(U0),...
' , \alpha = ' ,num2str(a),' ^{-1}, T = ',num2str(T),' '];
title(str)
%  
f=-fmax:df:fmax;
%     
UF=integral(@(t)U0*fun(t).*cos(2*pi*f*t),-T/2,T/2,'ArrayValued',true);
UU=U0*sqrt(pi)/a*exp(-(pi*f/a).^2);
subplot(3,1,2)
plot(f,UF,f,UU,'--')
ylim([min(UF)-.1 U0*sqrt(pi)/a+.1])
grid
xlabel('f, ')
ylabel('U_F(f), /')
title('  ()')
%   
subplot(3,1,3)
U=U0*sqrt(pi)/a*exp(-(pi*f/a).^2).*real(erf_series(a*T/2+1i*pi*f/a));
plot(f,U,f,UU,'--')
ylim([min(U)-.1 U0*sqrt(pi)/a+.1])
grid
xlabel('f, ')
ylabel('U(f), /')
title('  ()')
%   
dU=max(abs(UF-U));
fprintf('  : %e /.\n',dU)