% ..  .
%   MATLAB. 2023
%Script 4.10
%     
%   - 
clear all; close all; clc
%  
% 
U0=1;
%  
T=1;
%  
a=[1 0 1];
%  
na=length(a);
%     
tmin=-.5*T; tmax=na*T+.5*T;
%   
dt=.01;
%  
t=tmin:dt:tmax;
%    (  )
vF=[2/T 1/T .5/T .25/T];
% 
nF=length(vF);
%    
d=[.5*T:T:na;a]';
u=U0*pulstran(t,d,'rectpuls',T);
%     
for k=1:nF
F=vF(k);
y=0;
for ka = 1:na
ys=a(ka)*U0/pi*(sinint(2*pi*F*(t-(ka-1)*T))-sinint(2*pi*F*(t-ka*T)));
y=y+ys;
end
subplot(nF/2,nF/2,k)
plot(t,y,t,u,'b--')
grid
ymin=(min(a)-.3)*U0;
ymax=(max(a)+.6)*U0;
xlim([tmin tmax])
ylim([ymin ymax])
xlabel('t, ')
ylabel('y_{}(t), ')
x0=(na-1)*T/2;
y0=1.3*U0;
str=['F_c = ',num2str(F),' '];
text(x0,y0,str)
if k==1
title(['     , U_0 = ',...
num2str(U0),' , T = ',num2str(T),' , A = ',num2str(a)],...
'Units','normalized','Position',[1.155 1.03 0])    
end
end