% ..  .
%   MATLAB. 2023
%Script 6.7
%      
%  
clear all; close all; clc
%  
%  
m=3;
%  
K=2^m;
%     
umax=1;
umin=-umax;
% 
du=2*umax/K;
%     
uqmax=(K-2)*du/2;
uqmin=-uqmax;
%     
q=@(u) sign(u)*du.*fix(abs(u)/du).*(u>umin & u<umax)...
       +uqmax.*(u>=umax)+uqmin.*(u<=umin);
%  
u=umin:.0001:umax;
y=q(u);
%   
%[left,bottom,width,height]
subplot(2,1,1)
hp=get(gca,'position');
subplot(2,1,2)
hpl=get(gca,'position');
%  1- 
dh=.2;
subplot('position',[hp(1),hp(2)-dh,hp(3),hp(4)+dh])
%   
plot(u,y,u,u,'--')
grid
set(gca,'YMinorTick','on')
str_t=['   m = ',num2str(m)];
title(str_t)
xlabel('u, ')
ylabel('u_q, ')
legend(' ',' ',...
       'Location','SouthEast')
%  2- 
subplot('position',[hp(1),hpl(2),hp(3),hp(4)-dh])
%   
plot(u,y-u)
grid
set(gca,'YMinorTick','on')
title(' ')
xlabel('u, ')
ylabel('e, ')