% ..  .
%   MATLAB. 2023
%Script 7.6
% ,
%     
%  ,   ,   
%
clear all; close all; clc
%  
% 
U0=1;
% 
T=1;
%1- 
%     
tmin=-T; tmax=T;
dt=.001;
t=tmin:dt:tmax;
u=U0*rectpuls(t,T);
ug=-U0/pi*log(abs((t-T/2)./(t+T/2)));
subplot(2,2,1)
plot(t,u)
grid
xlim([tmin tmax])
ylim([0 1.1*U0])
xlabel('t, ')
ylabel('u(t), ')
str=[' u(t)  U_0 =',num2str(U0),...
    ' , T = ',num2str(T),' '];
title(str)
subplot(2,2,3)
plot(t,ug)
grid
xlim([tmin tmax])
ylim([-1.5*U0 1.5*U0])
xlabel('t, ')
ylabel('u_g(t), ')
title(' u_g(t)')
%       
fmin=-4/T; fmax=4/T;
df=.001;
f=fmin:df:fmax;
U=U0*T*sinc(f*T);
Ug=U.*sign(f);
subplot(2,2,2)
plot(f,U)
grid
xlim([fmin fmax])
xlabel('f, ')
ylabel('U(f), /')
title('  u(t)')
subplot(2,2,4)
plot(f,Ug)
grid
xlim([fmin fmax])
xlabel('f, ')
ylabel('jU_g(f), /')
title('  u_g(t)')
%2- 
%   
a=sqrt(u.^2+ug.^2);
figure;
subplot(2,2,1)
plot(t,a,t,u,':')
grid
xlim([tmin tmax])
legend('a(t)','u(t)','Location','North')
xlabel('t, ')
ylabel('a(t), ')
title('  z(t)')
%    
psi=atan2(ug,u);
subplot(2,2,3)
plot(t,psi)
grid
xlim([tmin tmax])
xlabel('t, ')
ylabel('\psi(t), ')
title('   z(t)')
%   
fmin=-.25/T; fmax=3/T;
df=.001;
f=fmin:df:fmax;
fun=@(x) (2*U0*T)^2*sinc(f*T).^2.*(x>=0);
Rz=fun(f);
subplot(2,2,2)
plot(f,Rz)
grid
xlim([fmin fmax])
xlabel('f, ')
ylabel('R_z(f), /')
title('  z(t)')
%    
omega=diff(psi)/dt; omega(end+1)=omega(end);
freq=omega/(2*pi);
subplot(2,2,4)
plot(freq,t)
grid
xlim([fmin fmax])
ylim([tmin tmax])
xlabel('f(t), ')
ylabel('t, ')
title('   z(t)')